3 # Copyright (C) The Arvados Authors. All rights reserved.
5 # SPDX-License-Identifier: CC-BY-SA-3.0
7 # If you want to test arvados in a single host, you can run this script, which
8 # will install it using salt masterless
9 # This script is run by the Vagrant file when you run it with
16 # capture the directory that the script is running from
17 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
21 echo >&2 "Usage: ${0} [-h] [-h]"
23 echo >&2 "${0} options:"
24 echo >&2 " -d, --debug Run salt installation in debug mode"
25 echo >&2 " -c <local.params>, --config <local.params> Path to the local.params config file"
26 echo >&2 " -t, --test Test cluster by running \`arvados-client diagnostics\`"
27 echo >&2 " and a simple workflow"
28 echo >&2 " -r, --roles List of Arvados roles to apply to the host, comma separated"
29 echo >&2 " Possible values are:"
31 echo >&2 " controller"
32 echo >&2 " dispatcher"
34 echo >&2 " keepbalance"
37 echo >&2 " monitoring"
42 echo >&2 " workbench2"
43 echo >&2 " Defaults to applying them all"
44 echo >&2 " -h, --help Display this help and exit"
45 echo >&2 " --dump-config <dest_dir> Dumps the pillars and states to a directory"
46 echo >&2 " This parameter does not perform any installation at all. It's"
47 echo >&2 " intended to give you a parsed set of configuration files so"
48 echo >&2 " you can inspect them or use them in you Saltstack infrastructure."
50 echo >&2 " - parses the pillar and states templates,"
51 echo >&2 " - downloads the helper formulas with their desired versions,"
52 echo >&2 " - prepares the 'top.sls' files both for pillars and states"
53 echo >&2 " for the selected role(s)"
54 echo >&2 " - writes the resulting files into <dest_dir>"
55 echo >&2 " -v, --vagrant Run in vagrant and use the /vagrant shared dir"
56 echo >&2 " --development Run in dev mode, using snakeoil certs"
61 # NOTE: This requires GNU getopt (part of the util-linux package on Debian-based distros).
62 if ! which getopt > /dev/null; then
63 echo >&2 "GNU getopt is required to run this script. Please install it and re-reun it"
67 TEMP=$(getopt -o c:dhp:r:tv \
68 --long config:,debug,development,dump-config:,help,roles:,test,vagrant \
72 then echo "Please check the parameters you entered and re-run again"
75 # Note the quotes around `$TEMP': they are essential!
78 while [ ${#} -ge 1 ]; do
90 if [[ ${2} = /* ]]; then
91 DUMP_SALT_CONFIG_DIR=${2}
93 DUMP_SALT_CONFIG_DIR=${PWD}/${2}
96 S_DIR="${DUMP_SALT_CONFIG_DIR}/salt"
98 F_DIR="${DUMP_SALT_CONFIG_DIR}/formulas"
100 P_DIR="${DUMP_SALT_CONFIG_DIR}/pillars"
102 T_DIR="${DUMP_SALT_CONFIG_DIR}/tests"
113 # Verify the role exists
114 if [[ ! "database,balancer,controller,keepstore,websocket,keepweb,workbench2,webshell,keepbalance,keepproxy,shell,workbench,dispatcher,monitoring" == *"$i"* ]]; then
115 echo "The role '${i}' is not a valid role"
119 ROLES="${ROLES:-} ${i}"
147 mkdir -p --mode=0700 /srv/salt/certs
149 if [ -f ${cert_dir}/${cert_name}.crt ]; then
150 install --mode=0600 ${cert_dir}/${cert_name}.crt /srv/salt/certs/arvados-${cert_name}.pem
152 echo "${cert_dir}/${cert_name}.crt does not exist. Exiting"
155 if [ -f ${cert_dir}/${cert_name}.key ]; then
156 install --mode=0600 ${cert_dir}/${cert_name}.key /srv/salt/certs/arvados-${cert_name}.key
158 echo "${cert_dir}/${cert_name}.key does not exist. Exiting"
163 apply_var_substitutions() {
166 sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
167 s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
168 s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
169 s#__CLUSTER__#${CLUSTER}#g;
170 s#__DOMAIN__#${DOMAIN}#g;
171 s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
172 s#__IP_INT__#${IP_INT}#g;
173 s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
174 s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
175 s#__INITIAL_USER__#${INITIAL_USER}#g;
176 s#__LE_AWS_REGION__#${LE_AWS_REGION:-}#g;
177 s#__LE_AWS_SECRET_ACCESS_KEY__#${LE_AWS_SECRET_ACCESS_KEY:-}#g;
178 s#__LE_AWS_ACCESS_KEY_ID__#${LE_AWS_ACCESS_KEY_ID:-}#g;
179 s#__DATABASE_NAME__#${DATABASE_NAME}#g;
180 s#__DATABASE_USER__#${DATABASE_USER}#g;
181 s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
182 s#__DATABASE_INT_IP__#${DATABASE_INT_IP:-}#g;
183 s#__DATABASE_EXTERNAL_SERVICE_HOST_OR_IP__#${DATABASE_EXTERNAL_SERVICE_HOST_OR_IP:-}#g;
184 s#__DATABASE_POSTGRESQL_VERSION__#${DATABASE_POSTGRESQL_VERSION}#g;
185 s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
186 s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
187 s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
188 s#__RELEASE__#${RELEASE}#g;
189 s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
190 s#__VERSION__#${VERSION}#g;
191 s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
192 s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
193 s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
194 s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
195 s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
196 s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
197 s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
198 s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
199 s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
200 s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
201 s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
202 s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
203 s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
204 s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
205 s#__SSL_KEY_ENCRYPTED__#${SSL_KEY_ENCRYPTED}#g;
206 s#__SSL_KEY_AWS_REGION__#${SSL_KEY_AWS_REGION:-}#g;
207 s#__SSL_KEY_AWS_SECRET_NAME__#${SSL_KEY_AWS_SECRET_NAME}#g;
208 s#__CONTROLLER_MAX_WORKERS__#${CONTROLLER_MAX_WORKERS:-}#g;
209 s#__CONTROLLER_MAX_QUEUED_REQUESTS__#${CONTROLLER_MAX_QUEUED_REQUESTS:-128}#g;
210 s#__CONTROLLER_MAX_GATEWAY_TUNNELS__#${CONTROLLER_MAX_GATEWAY_TUNNELS:-1000}#g;
211 s#__MONITORING_USERNAME__#${MONITORING_USERNAME}#g;
212 s#__MONITORING_EMAIL__#${MONITORING_EMAIL}#g;
213 s#__MONITORING_PASSWORD__#${MONITORING_PASSWORD}#g;
214 s#__DISPATCHER_SSH_PRIVKEY__#${DISPATCHER_SSH_PRIVKEY//$'\n'/\\n}#g;
215 s#__ENABLE_BALANCER__#${ENABLE_BALANCER}#g;
216 s#__DISABLED_CONTROLLER__#${DISABLED_CONTROLLER}#g;
217 s#__BALANCER_NODENAME__#${ROLE2NODES['balancer']:-}#g;
218 s#__PROMETHEUS_NODENAME__#${ROLE2NODES['monitoring']:-}#g;
219 s#__PROMETHEUS_DATA_RETENTION_TIME__#${PROMETHEUS_DATA_RETENTION_TIME:-15d}#g;
220 s#__CONTROLLER_NODES__#${ROLE2NODES['controller']:-}#g;
221 s#__NODELIST__#${NODELIST}#g;
222 s#__DISPATCHER_INT_IP__#${DISPATCHER_INT_IP}#g;
223 s#__KEEPBALANCE_INT_IP__#${KEEPBALANCE_INT_IP}#g;
224 s#__COMPUTE_AMI__#${COMPUTE_AMI:-}#g;
225 s#__COMPUTE_SG__#${COMPUTE_SG:-}#g;
226 s#__COMPUTE_SUBNET__#${COMPUTE_SUBNET:-}#g;
227 s#__COMPUTE_AWS_REGION__#${COMPUTE_AWS_REGION:-}#g;
228 s#__COMPUTE_USER__#${COMPUTE_USER:-}#g;
229 s#__KEEP_AWS_S3_BUCKET__#${KEEP_AWS_S3_BUCKET:-}#g;
230 s#__KEEP_AWS_IAM_ROLE__#${KEEP_AWS_IAM_ROLE:-}#g;
231 s#__KEEP_AWS_REGION__#${KEEP_AWS_REGION:-}#g" \
232 "${SRCFILE}" > "${DSTFILE}"
236 CONFIG_FILE="${SCRIPT_DIR}/local.params"
237 CONFIG_DIR="local_config_dir"
240 CONTROLLER_EXT_SSL_PORT=443
243 NGINX_INSTALL_SOURCE="install_from_repo"
248 # Hostnames/IPs used for single-host deploys
253 INITIAL_USER_EMAIL=""
254 INITIAL_USER_PASSWORD=""
256 CONTROLLER_EXT_SSL_PORT=8000
257 KEEP_EXT_SSL_PORT=25101
258 # Both for collections and downloads
259 KEEPWEB_EXT_SSL_PORT=9002
260 WEBSHELL_EXT_SSL_PORT=4202
261 WEBSOCKET_EXT_SSL_PORT=8002
262 WORKBENCH1_EXT_SSL_PORT=443
263 WORKBENCH2_EXT_SSL_PORT=3001
265 SSL_MODE="self-signed"
266 USE_LETSENCRYPT_ROUTE53="no"
267 CUSTOM_CERTS_DIR="${SCRIPT_DIR}/local_config_dir/certs"
269 GRAFANA_DASHBOARDS_DIR="${SCRIPT_DIR}/local_config_dir/dashboards"
271 ## These are ARVADOS-related parameters
272 # For a stable release, change RELEASE "production" and VERSION to the
273 # package version (including the iteration, e.g. X.Y.Z-1) of the
275 # The "local.params.example.*" files already set "RELEASE=production"
276 # to deploy production-ready packages
277 RELEASE="development"
280 # These are arvados-formula-related parameters
281 # An arvados-formula tag. For a stable release, this should be a
282 # branch name (e.g. X.Y-dev) or tag for the release.
283 # ARVADOS_TAG="2.2.0"
286 # We pin the salt version to avoid potential incompatibilities when a new
287 # stable version is released.
290 # Other formula versions we depend on
291 POSTGRES_TAG="7529300c287b1c288af0f494ca668c2217bd1c5d"
292 POSTGRES_URL="https://github.com/saltstack-formulas/postgres-formula.git"
296 LETSENCRYPT_TAG="v3.2.0"
297 LOGROTATE_TAG="v0.14.0"
298 PROMETHEUS_TAG="v5.6.5"
302 DUMP_SALT_CONFIG_DIR=""
305 STATES_TOP=${S_DIR}/top.sls
307 F_DIR="/srv/formulas"
310 PILLARS_TOP=${P_DIR}/top.sls
312 T_DIR="/tmp/cluster_tests"
317 declare -A ROLE2NODES
322 if [ ! -d ${CONFIG_DIR} ]; then
323 echo >&2 "You don't seem to have a config directory with pillars and states."
324 echo >&2 "Please create a '${CONFIG_DIR}' directory (as configured in your '${CONFIG_FILE}'). Please see"
325 echo >&2 " * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
326 echo >&2 " * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
330 if grep -rni 'fixme' ${CONFIG_FILE}.secrets ${CONFIG_FILE} ${CONFIG_DIR} ; then
331 echo >&2 "The config files has some parameters that need to be modified."
332 echo >&2 "Please, fix them and re-run the provision script."
336 if ! grep -qE '^[[:alnum:]]{5}$' <<<${CLUSTER} ; then
337 echo >&2 "ERROR: <CLUSTER> must be exactly 5 lowercase alphanumeric characters long"
338 echo >&2 "Fix the cluster name in the 'local.params' file and re-run the provision script"
342 # Only used in single_host/single_name deploys
343 if [ ! -z "${HOSTNAME_EXT:-}" ] ; then
344 # We need to add some extra control vars to manage a single certificate vs. multiple
345 USE_SINGLE_HOSTNAME="yes"
346 # Make sure that the value configured as IP_INT is a real IP on the system.
347 # If we don't error out early here when there is a mismatch, the formula will
348 # fail with hard to interpret nginx errors later on.
349 ip addr list |grep "${IP_INT}/" >/dev/null
350 if [[ $? -ne 0 ]]; then
351 echo "Unable to find the IP_INT address '${IP_INT}' on the system, please correct the value in local.params. Exiting..."
355 USE_SINGLE_HOSTNAME="no"
356 # We set this variable, anyway, so sed lines do not fail and we don't need to add more
358 HOSTNAME_EXT="${DOMAIN}"
361 if [ "${DUMP_CONFIG}" = "yes" ]; then
362 echo "The provision installer will just dump a config under ${DUMP_SALT_CONFIG_DIR} and exit"
364 OS_IDS="$(. /etc/os-release && echo "${ID:-} ${ID_LIKE:-}")"
365 echo "Detected distro families: $OS_IDS"
367 # Several of our formulas use the cron module, which requires the crontab
368 # command. We install systemd-cron to ensure we have that.
369 # The rest of these packages are required by the rest of the script.
370 for OS_ID in $OS_IDS; do
373 echo "WARNING! Disabling SELinux, see https://dev.arvados.org/issues/18019"
374 sed -i 's/SELINUX=enforcing/SELINUX=permissive/g' /etc/sysconfig/selinux
375 setenforce permissive
376 yum install -y curl git jq systemd-cron
380 DEBIAN_FRONTEND=noninteractive apt -o DPkg::Lock::Timeout=120 update
381 DEBIAN_FRONTEND=noninteractive apt install -y curl git jq systemd-cron
387 if which salt-call; then
388 echo "Salt already installed"
390 curl -L https://bootstrap.saltstack.com -o /tmp/bootstrap_salt.sh
391 sh /tmp/bootstrap_salt.sh -XdfP -x python3 stable ${SALT_VERSION}
392 /bin/systemctl stop salt-minion.service
393 /bin/systemctl disable salt-minion.service
396 # Set salt to masterless mode
397 cat > /etc/salt/minion << EOFSM
412 mkdir -p ${S_DIR} ${F_DIR} ${P_DIR} ${T_DIR}
414 # Get the formula and dependencies
415 cd ${F_DIR} || exit 1
416 echo "Cloning formulas"
417 test -d docker && ( cd docker && git fetch ) \
418 || git clone --quiet https://github.com/saltstack-formulas/docker-formula.git ${F_DIR}/docker
419 ( cd docker && git checkout --quiet tags/"${DOCKER_TAG}" )
422 test -d locale && ( cd locale && git fetch ) \
423 || git clone --quiet https://github.com/saltstack-formulas/locale-formula.git ${F_DIR}/locale
424 ( cd locale && git checkout --quiet tags/"${LOCALE_TAG}" )
427 test -d nginx && ( cd nginx && git fetch ) \
428 || git clone --quiet https://github.com/saltstack-formulas/nginx-formula.git ${F_DIR}/nginx
429 ( cd nginx && git checkout --quiet tags/"${NGINX_TAG}" )
432 test -d postgres && ( cd postgres && git fetch ) \
433 || git clone --quiet ${POSTGRES_URL} ${F_DIR}/postgres
434 ( cd postgres && git checkout --quiet "${POSTGRES_TAG}" )
437 test -d prometheus && ( cd prometheus && git fetch ) \
438 || git clone --quiet https://github.com/saltstack-formulas/prometheus-formula.git ${F_DIR}/prometheus
439 ( cd prometheus && git checkout --quiet tags/"${PROMETHEUS_TAG}" )
442 test -d grafana && ( cd grafana && git fetch ) \
443 || git clone --quiet https://github.com/saltstack-formulas/grafana-formula.git ${F_DIR}/grafana
444 ( cd grafana && git checkout --quiet "${GRAFANA_TAG}" )
446 echo "...letsencrypt"
447 test -d letsencrypt && ( cd letsencrypt && git fetch ) \
448 || git clone --quiet https://github.com/saltstack-formulas/letsencrypt-formula.git ${F_DIR}/letsencrypt
449 ( cd letsencrypt && git checkout --quiet tags/"${LETSENCRYPT_TAG}" )
452 test -d logrotate && ( cd logrotate && git fetch ) \
453 || git clone --quiet https://github.com/saltstack-formulas/logrotate-formula.git ${F_DIR}/logrotate
454 ( cd logrotate && git checkout --quiet tags/"${LOGROTATE_TAG}" )
457 test -d arvados || git clone --quiet https://git.arvados.org/arvados-formula.git ${F_DIR}/arvados
459 # If we want to try a specific branch of the formula
460 if [[ ! -z "${BRANCH:-}" && "x${BRANCH}" != "xmain" ]]; then
461 ( cd ${F_DIR}/arvados && git fetch && git checkout --quiet "${BRANCH}" || git checkout --quiet -t origin/"${BRANCH}" -b "${BRANCH}" )
462 elif [ "x${ARVADOS_TAG:-}" != "x" ]; then
463 ( cd ${F_DIR}/arvados && git checkout --quiet tags/"${ARVADOS_TAG}" -b "${ARVADOS_TAG}" )
466 if [ "x${VAGRANT:-}" = "xyes" ]; then
467 EXTRA_STATES_DIR="/home/vagrant/${CONFIG_DIR}/states"
468 SOURCE_PILLARS_DIR="/home/vagrant/${CONFIG_DIR}/pillars"
469 SOURCE_TOFS_DIR="/home/vagrant/${CONFIG_DIR}/tofs"
470 SOURCE_TESTS_DIR="/home/vagrant/${TESTS_DIR}"
472 EXTRA_STATES_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/states"
473 SOURCE_PILLARS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/pillars"
474 SOURCE_TOFS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/tofs"
475 SOURCE_TESTS_DIR="${SCRIPT_DIR}/${TESTS_DIR}"
478 SOURCE_STATES_DIR="${EXTRA_STATES_DIR}"
480 echo "Writing pillars and states"
482 # Replace variables (cluster, domain, etc) in the pillars, states and tests
483 # to ease deployment for newcomers
484 if [ ! -d "${SOURCE_PILLARS_DIR}" ]; then
485 echo "${SOURCE_PILLARS_DIR} does not exist or is not a directory. Exiting."
488 for f in $(ls "${SOURCE_PILLARS_DIR}"/*); do
489 apply_var_substitutions "${f}" "${P_DIR}"/$(basename "${f}")
492 if [ ! -d "${SOURCE_TESTS_DIR}" ]; then
493 echo "WARNING: The tests directory was not copied to \"${SOURCE_TESTS_DIR}\"."
494 if [ "x${TEST:-}" = "xyes" ]; then
495 echo "WARNING: Disabling tests for this installation."
500 # Replace cluster and domain name in the test files
501 for f in $(ls "${SOURCE_TESTS_DIR}"/*); do
502 FILTERS="s#__CLUSTER__#${CLUSTER}#g;
503 s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
504 s#__DOMAIN__#${DOMAIN}#g;
505 s#__IP_INT__#${IP_INT}#g;
506 s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
507 s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g
508 s#__INITIAL_USER__#${INITIAL_USER}#g;
509 s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
510 s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g"
511 if [ "$USE_SINGLE_HOSTNAME" = "yes" ]; then
512 FILTERS="s#__CLUSTER__.__DOMAIN__#${HOSTNAME_EXT}#g;
516 "${f}" > ${T_DIR}/$(basename "${f}")
518 chmod 755 ${T_DIR}/run-test.sh
521 # Replace helper state files that differ from the formula's examples
522 if [ -d "${SOURCE_STATES_DIR}" ]; then
523 mkdir -p "${F_DIR}"/extra/extra
524 rm -rf "${F_DIR}"/extra/extra/*
526 for f in $(ls "${SOURCE_STATES_DIR}"/*); do
527 apply_var_substitutions "${f}" "${F_DIR}/extra/extra"/$(basename "${f}")
531 # Now, we build the SALT states/pillars trees
532 # As we need to separate both states and pillars in case we want specific
533 # roles, we iterate on both at the same time
535 # Formula template overrides (TOFS)
536 # See: https://template-formula.readthedocs.io/en/latest/TOFS_pattern.html#template-override
537 if [ -d ${SOURCE_TOFS_DIR} ]; then
538 find ${SOURCE_TOFS_DIR} -mindepth 1 -maxdepth 1 -type d -exec cp -r "{}" ${S_DIR} \;
542 cat > ${STATES_TOP} << EOFTSLS
549 cat > ${PILLARS_TOP} << EOFPSLS
556 # States, extra states
557 if [ -d "${F_DIR}"/extra/extra ]; then
558 SKIP_SNAKE_OIL="snakeoil_certs"
560 if [[ "$DEV_MODE" = "yes" || "${SSL_MODE}" == "self-signed" ]] ; then
561 # In dev mode, we create some snake oil certs that we'll
562 # use as CUSTOM_CERTS, so we don't skip the states file.
563 # Same when using self-signed certificates.
564 SKIP_SNAKE_OIL="dont_add_snakeoil_certs"
566 for f in $(ls "${F_DIR}"/extra/extra/*.sls | egrep -v "${SKIP_SNAKE_OIL}|shell_"); do
567 echo " - extra.$(basename ${f} | sed 's/.sls$//g')" >> ${STATES_TOP}
569 # Use byo or self-signed certificates
570 if [ "${SSL_MODE}" != "lets-encrypt" ]; then
571 mkdir -p "${F_DIR}"/extra/extra/files
575 # If we want specific roles for a node, just add the desired states
576 # and its dependencies
577 if [ -z "${ROLES:-}" ]; then
579 echo " - nginx.passenger" >> ${STATES_TOP}
580 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
581 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
582 grep -q "aws_credentials" ${STATES_TOP} || echo " - extra.aws_credentials" >> ${STATES_TOP}
584 grep -q "letsencrypt" ${STATES_TOP} || echo " - letsencrypt" >> ${STATES_TOP}
586 mkdir -p --mode=0700 /srv/salt/certs
587 if [ "${SSL_MODE}" = "bring-your-own" ]; then
588 # Copy certs to formula extra/files
589 install --mode=0600 ${CUSTOM_CERTS_DIR}/* /srv/salt/certs/
590 # We add the custom_certs state
591 grep -q "custom_certs" ${STATES_TOP} || echo " - extra.custom_certs" >> ${STATES_TOP}
592 if [ "${SSL_KEY_ENCRYPTED}" = "yes" ]; then
593 grep -q "ssl_key_encrypted" ${STATES_TOP} || echo " - extra.ssl_key_encrypted" >> ${STATES_TOP}
596 # In self-signed mode, the certificate files will be created and put in the
597 # destination directory by the snakeoil_certs.sls state file
600 echo " - postgres" >> ${STATES_TOP}
601 echo " - logrotate" >> ${STATES_TOP}
602 echo " - docker.software" >> ${STATES_TOP}
603 echo " - arvados.repo" >> ${STATES_TOP}
604 echo " - arvados.config" >> ${STATES_TOP}
605 echo " - arvados.ruby" >> ${STATES_TOP}
606 echo " - arvados.api" >> ${STATES_TOP}
607 echo " - arvados.controller" >> ${STATES_TOP}
608 echo " - arvados.keepstore" >> ${STATES_TOP}
609 echo " - arvados.websocket" >> ${STATES_TOP}
610 echo " - arvados.keepweb" >> ${STATES_TOP}
611 echo " - arvados.workbench2" >> ${STATES_TOP}
612 echo " - arvados.keepproxy" >> ${STATES_TOP}
613 echo " - arvados.shell" >> ${STATES_TOP}
614 echo " - arvados.dispatcher" >> ${STATES_TOP}
615 echo " - extra.shell_sudo_passwordless" >> ${STATES_TOP}
616 echo " - extra.shell_cron_add_login_sync" >> ${STATES_TOP}
617 echo " - extra.passenger_rvm" >> ${STATES_TOP}
618 echo " - extra.workbench1_uninstall" >> ${STATES_TOP}
621 echo " - docker" >> ${PILLARS_TOP}
622 echo " - nginx_api_configuration" >> ${PILLARS_TOP}
623 echo " - logrotate" >> ${PILLARS_TOP}
624 echo " - logrotate_api" >> ${PILLARS_TOP}
625 echo " - nginx_controller_configuration" >> ${PILLARS_TOP}
626 echo " - nginx_keepproxy_configuration" >> ${PILLARS_TOP}
627 echo " - nginx_keepweb_configuration" >> ${PILLARS_TOP}
628 echo " - nginx_passenger" >> ${PILLARS_TOP}
629 echo " - nginx_websocket_configuration" >> ${PILLARS_TOP}
630 echo " - nginx_webshell_configuration" >> ${PILLARS_TOP}
631 echo " - nginx_workbench2_configuration" >> ${PILLARS_TOP}
632 echo " - nginx_workbench_configuration" >> ${PILLARS_TOP}
633 echo " - logrotate_wb1" >> ${PILLARS_TOP}
634 echo " - postgresql" >> ${PILLARS_TOP}
636 # We need to tweak the Nginx's pillar depending whether we want plan nginx or nginx+passenger
637 NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
638 sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
640 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
641 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
642 grep -q "aws_credentials" ${PILLARS_TOP} || echo " - aws_credentials" >> ${PILLARS_TOP}
644 grep -q "letsencrypt" ${PILLARS_TOP} || echo " - letsencrypt" >> ${PILLARS_TOP}
646 hosts=("controller" "websocket" "workbench" "workbench2" "webshell" "keepproxy")
647 if [ ${USE_SINGLE_HOSTNAME} = "no" ]; then
648 hosts+=("download" "collections")
653 for c in "${hosts[@]}"; do
654 # Are we in a single-host-single-hostname env?
655 if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
656 # Are we in a single-host-single-hostname env?
657 CERT_NAME=${HOSTNAME_EXT}
659 # We are in a multiple-hostnames env
660 CERT_NAME=${c}.${DOMAIN}
663 # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
664 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${CERT_NAME}*/g;
665 s#__CERT_PEM__#/etc/letsencrypt/live/${CERT_NAME}/fullchain.pem#g;
666 s#__CERT_KEY__#/etc/letsencrypt/live/${CERT_NAME}/privkey.pem#g" \
667 ${P_DIR}/nginx_${c}_configuration.sls
670 # Use custom certs (either dev mode or prod)
671 grep -q "extra_custom_certs" ${PILLARS_TOP} || echo " - extra_custom_certs" >> ${PILLARS_TOP}
672 # And add the certs in the custom_certs pillar
673 echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
674 echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
676 for c in controller websocket workbench workbench2 webshell keepweb keepproxy; do
677 # Are we in a single-host-single-hostname env?
678 if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
679 # Are we in a single-host-single-hostname env?
680 CERT_NAME=${HOSTNAME_EXT}
682 # We are in a multiple-hostnames env
686 if [[ "$SSL_MODE" == "bring-your-own" ]]; then
687 copy_custom_cert ${CUSTOM_CERTS_DIR} ${CERT_NAME}
690 grep -q ${CERT_NAME} ${P_DIR}/extra_custom_certs.sls || echo " - ${CERT_NAME}" >> ${P_DIR}/extra_custom_certs.sls
692 # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
693 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_${CERT_NAME}_cert_file_copy/g;
694 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${CERT_NAME}.pem#g;
695 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${CERT_NAME}.key#g" \
696 ${P_DIR}/nginx_${c}_configuration.sls
700 # If we add individual roles, make sure we add the repo first
701 echo " - arvados.repo" >> ${STATES_TOP}
702 # We add the extra_custom_certs state
703 grep -q "extra.custom_certs" ${STATES_TOP} || echo " - extra.custom_certs" >> ${STATES_TOP}
704 if [ "${SSL_KEY_ENCRYPTED}" = "yes" ]; then
705 grep -q "ssl_key_encrypted" ${STATES_TOP} || echo " - extra.ssl_key_encrypted" >> ${STATES_TOP}
708 # And we add the basic part for the certs pillar
709 if [ "${SSL_MODE}" != "lets-encrypt" ]; then
710 # And add the certs in the custom_certs pillar
711 echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
712 echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
713 grep -q "extra_custom_certs" ${PILLARS_TOP} || echo " - extra_custom_certs" >> ${PILLARS_TOP}
716 # Prometheus state on all nodes due to the node exporter below
717 grep -q "\- prometheus$" ${STATES_TOP} || echo " - prometheus" >> ${STATES_TOP}
718 # Prometheus node exporter pillar
719 grep -q "prometheus_node_exporter" ${PILLARS_TOP} || echo " - prometheus_node_exporter" >> ${PILLARS_TOP}
721 for R in ${ROLES:-}; do
725 grep -q "\- postgres$" ${STATES_TOP} || echo " - postgres" >> ${STATES_TOP}
726 grep -q "extra.prometheus_pg_exporter" ${STATES_TOP} || echo " - extra.prometheus_pg_exporter" >> ${STATES_TOP}
728 grep -q "postgresql" ${PILLARS_TOP} || echo " - postgresql" >> ${PILLARS_TOP}
729 grep -q "prometheus_pg_exporter" ${PILLARS_TOP} || echo " - prometheus_pg_exporter" >> ${PILLARS_TOP}
732 ### Support files ###
733 GRAFANA_DASHBOARDS_DEST_DIR=/srv/salt/dashboards
734 mkdir -p "${GRAFANA_DASHBOARDS_DEST_DIR}"
735 rm -f "${GRAFANA_DASHBOARDS_DEST_DIR}"/*
736 # "ArvadosPromDataSource" is the hardcoded UID for Prometheus' datasource
738 for f in $(ls "${GRAFANA_DASHBOARDS_DIR}"/*.json); do
739 sed "s#__TLS_EXPIRATION_YELLOW__#${TLS_EXPIRATION_YELLOW}#g;
740 s#__TLS_EXPIRATION_GREEN__#${TLS_EXPIRATION_GREEN}#g;
741 s#\${DS_PROMETHEUS}#ArvadosPromDataSource#g" \
742 "${f}" > "${GRAFANA_DASHBOARDS_DEST_DIR}"/$(basename "${f}")
746 grep -q "\- nginx$" ${STATES_TOP} || echo " - nginx" >> ${STATES_TOP}
747 grep -q "extra.nginx_prometheus_configuration" ${STATES_TOP} || echo " - extra.nginx_prometheus_configuration" >> ${STATES_TOP}
749 grep -q "\- grafana$" ${STATES_TOP} || echo " - grafana" >> ${STATES_TOP}
750 grep -q "extra.grafana_datasource" ${STATES_TOP} || echo " - extra.grafana_datasource" >> ${STATES_TOP}
751 grep -q "extra.grafana_dashboards" ${STATES_TOP} || echo " - extra.grafana_dashboards" >> ${STATES_TOP}
752 grep -q "extra.grafana_admin_user" ${STATES_TOP} || echo " - extra.grafana_admin_user" >> ${STATES_TOP}
754 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
755 grep -q "letsencrypt" ${STATES_TOP} || echo " - letsencrypt" >> ${STATES_TOP}
756 if [ "x${USE_LETSENCRYPT_ROUTE53:-}" = "xyes" ]; then
757 grep -q "aws_credentials" ${STATES_TOP} || echo " - aws_credentials" >> ${STATES_TOP}
759 elif [ "${SSL_MODE}" = "bring-your-own" ]; then
760 for SVC in grafana prometheus; do
761 copy_custom_cert ${CUSTOM_CERTS_DIR} ${SVC}
765 grep -q "prometheus_server" ${PILLARS_TOP} || echo " - prometheus_server" >> ${PILLARS_TOP}
766 grep -q "grafana" ${PILLARS_TOP} || echo " - grafana" >> ${PILLARS_TOP}
767 for SVC in grafana prometheus; do
768 grep -q "nginx_${SVC}_configuration" ${PILLARS_TOP} || echo " - nginx_${SVC}_configuration" >> ${PILLARS_TOP}
770 grep -q "nginx_snippets" ${PILLARS_TOP} || echo " - nginx_snippets" >> ${PILLARS_TOP}
771 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
772 grep -q "letsencrypt" ${PILLARS_TOP} || echo " - letsencrypt" >> ${PILLARS_TOP}
773 for SVC in grafana prometheus; do
774 grep -q "letsencrypt_${SVC}_configuration" ${PILLARS_TOP} || echo " - letsencrypt_${SVC}_configuration" >> ${PILLARS_TOP}
775 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${SVC}.${DOMAIN}*/g;
776 s#__CERT_PEM__#/etc/letsencrypt/live/${SVC}.${DOMAIN}/fullchain.pem#g;
777 s#__CERT_KEY__#/etc/letsencrypt/live/${SVC}.${DOMAIN}/privkey.pem#g" \
778 ${P_DIR}/nginx_${SVC}_configuration.sls
780 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
781 grep -q "aws_credentials" ${PILLARS_TOP} || echo " - aws_credentials" >> ${PILLARS_TOP}
783 elif [ "${SSL_MODE}" = "bring-your-own" ]; then
784 grep -q "ssl_key_encrypted" ${PILLARS_TOP} || echo " - ssl_key_encrypted" >> ${PILLARS_TOP}
785 for SVC in grafana prometheus; do
786 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_${SVC}_cert_file_copy/g;
787 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${SVC}.pem#g;
788 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${SVC}.key#g" \
789 ${P_DIR}/nginx_${SVC}_configuration.sls
790 grep -q ${SVC} ${P_DIR}/extra_custom_certs.sls || echo " - ${SVC}" >> ${P_DIR}/extra_custom_certs.sls
796 grep -q "\- nginx$" ${STATES_TOP} || echo " - nginx" >> ${STATES_TOP}
798 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
799 grep -q "letsencrypt" ${STATES_TOP} || echo " - letsencrypt" >> ${STATES_TOP}
800 if [ "x${USE_LETSENCRYPT_ROUTE53:-}" = "xyes" ]; then
801 grep -q "aws_credentials" ${STATES_TOP} || echo " - aws_credentials" >> ${STATES_TOP}
803 elif [ "${SSL_MODE}" = "bring-your-own" ]; then
804 copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
808 grep -q "nginx_${R}_configuration" ${PILLARS_TOP} || echo " - nginx_${R}_configuration" >> ${PILLARS_TOP}
810 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
811 grep -q "letsencrypt" ${PILLARS_TOP} || echo " - letsencrypt" >> ${PILLARS_TOP}
813 grep -q "letsencrypt_${R}_configuration" ${PILLARS_TOP} || echo " - letsencrypt_${R}_configuration" >> ${PILLARS_TOP}
814 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${ROLE2NODES['balancer']}*/g;
815 s#__CERT_PEM__#/etc/letsencrypt/live/${ROLE2NODES['balancer']}/fullchain.pem#g;
816 s#__CERT_KEY__#/etc/letsencrypt/live/${ROLE2NODES['balancer']}/privkey.pem#g" \
817 ${P_DIR}/nginx_${R}_configuration.sls
819 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
820 grep -q "aws_credentials" ${PILLARS_TOP} || echo " - aws_credentials" >> ${PILLARS_TOP}
822 elif [ "${SSL_MODE}" = "bring-your-own" ]; then
823 grep -q "ssl_key_encrypted" ${PILLARS_TOP} || echo " - ssl_key_encrypted" >> ${PILLARS_TOP}
824 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_${R}_cert_file_copy/g;
825 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
826 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
827 ${P_DIR}/nginx_${R}_configuration.sls
828 grep -q "${R}" ${P_DIR}/extra_custom_certs.sls || echo " - ${R}" >> ${P_DIR}/extra_custom_certs.sls
833 grep -q " - logrotate" ${STATES_TOP} || echo " - logrotate" >> ${STATES_TOP}
834 if grep -q " - nginx.*$" ${STATES_TOP}; then
835 sed -i s/"^ - nginx.*$"/" - nginx.passenger"/g ${STATES_TOP}
837 echo " - nginx.passenger" >> ${STATES_TOP}
839 echo " - extra.passenger_rvm" >> ${STATES_TOP}
840 grep -q "^ - postgres\\.client$" ${STATES_TOP} || echo " - postgres.client" >> ${STATES_TOP}
842 ### If we don't install and run LE before arvados-api-server, it fails and breaks everything
843 ### after it. So we add this here as we are, after all, sharing the host for api and controller
844 if [ "${ENABLE_BALANCER}" == "no" ]; then
845 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
846 if [ "x${USE_LETSENCRYPT_ROUTE53:-}" = "xyes" ]; then
847 grep -q "aws_credentials" ${STATES_TOP} || echo " - aws_credentials" >> ${STATES_TOP}
849 grep -q "letsencrypt" ${STATES_TOP} || echo " - letsencrypt" >> ${STATES_TOP}
850 elif [ "${SSL_MODE}" = "bring-your-own" ]; then
851 copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
852 grep -q controller ${P_DIR}/extra_custom_certs.sls || echo " - controller" >> ${P_DIR}/extra_custom_certs.sls
855 grep -q "arvados.api" ${STATES_TOP} || echo " - arvados.api" >> ${STATES_TOP}
856 grep -q "arvados.controller" ${STATES_TOP} || echo " - arvados.controller" >> ${STATES_TOP}
859 grep -q "logrotate" ${PILLARS_TOP} || echo " - logrotate" >> ${PILLARS_TOP}
860 grep -q "logrotate_api" ${PILLARS_TOP} || echo " - logrotate_api" >> ${PILLARS_TOP}
861 grep -q "aws_credentials" ${PILLARS_TOP} || echo " - aws_credentials" >> ${PILLARS_TOP}
862 grep -q "postgresql" ${PILLARS_TOP} || echo " - postgresql" >> ${PILLARS_TOP}
863 grep -q "nginx_passenger" ${PILLARS_TOP} || echo " - nginx_passenger" >> ${PILLARS_TOP}
864 grep -q "nginx_snippets" ${PILLARS_TOP} || echo " - nginx_snippets" >> ${PILLARS_TOP}
865 grep -q "nginx_api_configuration" ${PILLARS_TOP} || echo " - nginx_api_configuration" >> ${PILLARS_TOP}
866 grep -q "nginx_controller_configuration" ${PILLARS_TOP} || echo " - nginx_controller_configuration" >> ${PILLARS_TOP}
868 if [ "${ENABLE_BALANCER}" == "no" ]; then
869 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
870 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
871 grep -q "aws_credentials" ${PILLARS_TOP} || echo " - aws_credentials" >> ${PILLARS_TOP}
874 grep -q "letsencrypt" ${PILLARS_TOP} || echo " - letsencrypt" >> ${PILLARS_TOP}
875 grep -q "letsencrypt_${R}_configuration" ${PILLARS_TOP} || echo " - letsencrypt_${R}_configuration" >> ${PILLARS_TOP}
876 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${DOMAIN}*/g;
877 s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${DOMAIN}/fullchain.pem#g;
878 s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${DOMAIN}/privkey.pem#g" \
879 ${P_DIR}/nginx_${R}_configuration.sls
881 grep -q "ssl_key_encrypted" ${PILLARS_TOP} || echo " - ssl_key_encrypted" >> ${PILLARS_TOP}
882 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_${R}_cert_file_copy/g;
883 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
884 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
885 ${P_DIR}/nginx_${R}_configuration.sls
886 grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo " - ${R}" >> ${P_DIR}/extra_custom_certs.sls
889 # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
890 NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
891 sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
893 "websocket" | "workbench" | "workbench2" | "webshell" | "keepweb" | "keepproxy")
895 grep -q "\- nginx$" ${STATES_TOP} || echo " - nginx" >> ${STATES_TOP}
897 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
898 if [ "x${USE_LETSENCRYPT_ROUTE53:-}" = "xyes" ]; then
899 grep -q "aws_credentials" ${STATES_TOP} || echo " - aws_credentials" >> ${STATES_TOP}
901 grep -q "letsencrypt" ${STATES_TOP} || echo " - letsencrypt" >> ${STATES_TOP}
903 # Use custom certs, special case for keepweb
904 if [ ${R} = "keepweb" ]; then
905 if [ "${SSL_MODE}" = "bring-your-own" ]; then
906 copy_custom_cert ${CUSTOM_CERTS_DIR} download
907 copy_custom_cert ${CUSTOM_CERTS_DIR} collections
910 if [ "${SSL_MODE}" = "bring-your-own" ]; then
911 copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
916 # webshell role is just a nginx vhost, so it has no state
917 # workbench role is deprecated since 2.7.0
918 if [[ "${R}" != "webshell" && "${R}" != "workbench" ]]; then
919 grep -q "arvados.${R}" ${STATES_TOP} || echo " - arvados.${R}" >> ${STATES_TOP}
921 # Make sure wb1's package get uninstalled
922 if [[ "${R}" == "workbench" ]]; then
923 grep -q "workbench1_uninstall" ${STATES_TOP} || echo " - extra.workbench1_uninstall" >> ${STATES_TOP}
927 grep -q "nginx_${R}_configuration" ${PILLARS_TOP} || echo " - nginx_${R}_configuration" >> ${PILLARS_TOP}
928 grep -q "nginx_snippets" ${PILLARS_TOP} || echo " - nginx_snippets" >> ${PILLARS_TOP}
929 # Special case for keepweb
930 if [ ${R} = "keepweb" ]; then
931 grep -q "nginx_download_configuration" ${PILLARS_TOP} || echo " - nginx_download_configuration" >> ${PILLARS_TOP}
932 grep -q "nginx_collections_configuration" ${PILLARS_TOP} || echo " - nginx_collections_configuration" >> ${PILLARS_TOP}
935 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
936 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
937 grep -q "aws_credentials" ${PILLARS_TOP} || echo " - aws_credentials" >> ${PILLARS_TOP}
939 grep -q "letsencrypt" ${PILLARS_TOP} || echo " - letsencrypt" >> ${PILLARS_TOP}
940 grep -q "letsencrypt_${R}_configuration" ${PILLARS_TOP} || echo " - letsencrypt_${R}_configuration" >> ${PILLARS_TOP}
942 # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
943 # Special case for keepweb
944 if [ ${R} = "keepweb" ]; then
945 for kwsub in download collections; do
946 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${kwsub}.${DOMAIN}*/g;
947 s#__CERT_PEM__#/etc/letsencrypt/live/${kwsub}.${DOMAIN}/fullchain.pem#g;
948 s#__CERT_KEY__#/etc/letsencrypt/live/${kwsub}.${DOMAIN}/privkey.pem#g" \
949 ${P_DIR}/nginx_${kwsub}_configuration.sls
952 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${DOMAIN}*/g;
953 s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${DOMAIN}/fullchain.pem#g;
954 s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${DOMAIN}/privkey.pem#g" \
955 ${P_DIR}/nginx_${R}_configuration.sls
958 grep -q "ssl_key_encrypted" ${PILLARS_TOP} || echo " - ssl_key_encrypted" >> ${PILLARS_TOP}
959 # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
960 # Special case for keepweb
961 if [ ${R} = "keepweb" ]; then
962 for kwsub in download collections; do
963 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_${kwsub}_cert_file_copy/g;
964 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${kwsub}.pem#g;
965 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${kwsub}.key#g" \
966 ${P_DIR}/nginx_${kwsub}_configuration.sls
967 grep -q ${kwsub} ${P_DIR}/extra_custom_certs.sls || echo " - ${kwsub}" >> ${P_DIR}/extra_custom_certs.sls
970 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_${R}_cert_file_copy/g;
971 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
972 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
973 ${P_DIR}/nginx_${R}_configuration.sls
974 grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo " - ${R}" >> ${P_DIR}/extra_custom_certs.sls
977 # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
978 sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
982 echo " - extra.shell_sudo_passwordless" >> ${STATES_TOP}
983 echo " - extra.shell_cron_add_login_sync" >> ${STATES_TOP}
984 grep -q "docker" ${STATES_TOP} || echo " - docker.software" >> ${STATES_TOP}
985 grep -q "arvados.${R}" ${STATES_TOP} || echo " - arvados.${R}" >> ${STATES_TOP}
987 grep -q "docker" ${PILLARS_TOP} || echo " - docker" >> ${PILLARS_TOP}
989 "dispatcher" | "keepbalance" | "keepstore")
991 grep -q "arvados.${R}" ${STATES_TOP} || echo " - arvados.${R}" >> ${STATES_TOP}
993 # ATM, no specific pillar needed
996 echo "Unknown role ${R}"
1003 if [ "${DUMP_CONFIG}" = "yes" ]; then
1004 # We won't run the rest of the script because we're just dumping the config
1008 # Now run the install
1009 salt-call --state-output=mixed --local state.apply -l ${LOG_LEVEL}
1011 # Finally, make sure that /etc/hosts is not overwritten on reboot
1012 if [ -d /etc/cloud/cloud.cfg.d ]; then
1013 # TODO: will this work on CentOS?
1014 sed -i 's/^manage_etc_hosts: true/#manage_etc_hosts: true/g' /etc/cloud/cloud.cfg.d/*
1017 # Leave a copy of the Arvados CA so the user can copy it where it's required
1018 if [ "${SSL_MODE}" = "self-signed" ]; then
1019 echo "Copying the Arvados CA certificate '${DOMAIN}-arvados-snakeoil-ca.crt' to the installer dir, so you can import it"
1020 if [ "x${VAGRANT:-}" = "xyes" ]; then
1021 cp /etc/ssl/certs/arvados-snakeoil-ca.pem /vagrant/${DOMAIN}-arvados-snakeoil-ca.pem
1023 cp /etc/ssl/certs/arvados-snakeoil-ca.pem ${SCRIPT_DIR}/${DOMAIN}-arvados-snakeoil-ca.crt
1027 if [ "x${VAGRANT:-}" = "xyes" ]; then
1028 # If running in a vagrant VM, also add default user to docker group
1029 echo "Adding the vagrant user to the docker group"
1030 usermod -a -G docker vagrant
1033 # Test that the installation finished correctly
1034 if [ "x${TEST:-}" = "xyes" ]; then
1036 # If we use RVM, we need to run this with it, or most ruby commands will fail
1038 if [ -x /usr/local/rvm/bin/rvm-exec ]; then
1039 RVM_EXEC="/usr/local/rvm/bin/rvm-exec"
1041 ${RVM_EXEC} ./run-test.sh